SystemOrganization addCategory: #'TADP TP1'!

Trait named: #ConstructorConNombre
	uses: {}
	category: 'TADP TP1'!

!ConstructorConNombre classSide methodsFor: 'as yet unclassified' stamp: 'MartinPrete 5/2/2012 16:04'!
nombre: aName
	^(self new) nombre: aName.! !

Trait named: #TraitManejadorDeColecciones
	uses: {}
	category: 'TADP TP1'!

Trait named: #ConAgenda
	uses: TraitManejadorDeColecciones
	category: 'TADP TP1'!

ConAgenda classTrait
	uses: TraitManejadorDeColecciones classTrait!

!ConAgenda methodsFor: 'printing' stamp: 'ArielCapozzoli 4/21/2012 00:51'!
agendarReunion: unaReunion
	|evento|.
	evento := Evento new.
	evento horaInicio: unaReunion horaInicio.	
	evento horaFin: unaReunion horaFin.
	(self agenda) agregarEvento: evento.! !

!ConAgenda methodsFor: 'printing' stamp: 'ArielCapozzoli 4/21/2012 00:49'!
recorrerAgendaEnDia: unaFecha
	^ (self agenda) eventosEnLaFecha: unaFecha.
		! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 20:03'!
buscarMayorEn: unaColeccion usandoComoValorInicial:unValorInicial  comprador: unBloqueComparador
^unaColeccion inject: unValorInicial into: [:a :c | ((unBloqueComparador value: a) > (unBloqueComparador value: c))                 ifTrue: [a]
   ifFalse: [c]].! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 20:04'!
buscarMenorEn: unaColeccion usandoComoValorInicial:unValorInicial  comprador: unBloqueComparador
^unaColeccion inject: unValorInicial into: [:a :c | ((unBloqueComparador value: a) < (unBloqueComparador value: c))                 ifTrue: [a]
   ifFalse: [c]].! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/27/2012 16:04'!
removerDuplicadosDe: unaColeccion condicionIgualdad: unBloqueCondicional
	^unaColeccion copy do:[:a | unaColeccion copy do:[:b | (unBloqueCondicional value:a value:b) ifTrue: [unaColeccion remove: a]]]! !

Trait named: #TraitRol
	uses: {}
	category: 'TADP TP1'!

!TraitRol methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 18:07'!
= otraClaseRol
	^(self isKindOf: otraClaseRol) ! !

!TraitRol methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 17:54'!
requerisCatering
	^((self isKindOf: Gerente) | (self isKindOf: ProjectLeader))! !

Object subclass: #Agenda
	uses: TraitManejadorDeColecciones
	instanceVariableNames: 'eventos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Agenda class
	uses: TraitManejadorDeColecciones classTrait
	instanceVariableNames: ''!

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:38'!
agregarEvento:unEvento
	eventos add: unEvento.
	"eventos sort."! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:26'!
eventos
	^(eventos sort)! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 02:05'!
eventosEnLaFecha:unaFecha
	^eventos select:[:unEvento | unEvento fecha = unaFecha ]! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 16:22'!
filtrarEventos:coleccionEventos enLaFecha:unaFecha
	^coleccionEventos select:[:unEvento | unEvento fecha = unaFecha ]! !

!Agenda methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/6/2012 15:22'!
initialize 
	eventos:= OrderedCollection new.! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 16:03'!
tiemposLibresQueDurenComoMinimo:unaDuracion desde:horaEntrada hasta:horaSalida
	|tiemposLibres condicion|	
	tiemposLibres := OrderedCollection new.
	
	"Pedimos a cada evento que nos diga que horas del dia deja libres."
	eventos do:[:e | tiemposLibres addAll: (e horasQueDejaLibre)].

	"Removemos eventos que esten fuera del rango y acotamos para que queden dentro de Entrada/Salida de la Persona."
	tiemposLibres := (tiemposLibres select:[:e |  (((e horaFin) > horaEntrada)  & ((e horaInicio) < horaSalida))])
		 collect:[:e | e ajustarInicio: horaEntrada fin: horaSalida].	

	"Terminamos de limpiar los tiempos que pisen a otros eventos dentro del dia."
	tiemposLibres copy do:[ :tl | 
		eventos do:[:e | (e estaContenidoDentroDe: tl) ifTrue:[tl horaFin:e horaInicio] ifFalse:[(tl seSuperPoneCon: e) ifTrue: [tl acotarSegun:e]]]].

	"Filtramos las franjas de tiempo libre que duren lo requerido y removemos duplicados."
	tiemposLibres := ((tiemposLibres select:[:e | (e duraMasQue: unaDuracion)]) asSet) asOrderedCollection. 
	condicion:=[:x :y | ((x~=y)&((x horaInicio) = (y horaInicio))&((x horaFin) = (y horaFin)))].
	self removerDuplicadosDe: tiemposLibres condicionIgualdad: condicion.
	
	"Finalmenter ordenamos las franjas horarias por hora de inicio."
	tiemposLibres sort.
		
	^tiemposLibres! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 16:09'!
tieneTiempoLibreParaElEvento:unEvento
	^ unEvento seSuperPoneConAlgunOtroEvento: (self eventos).! !

Object subclass: #Arquitecto
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Arquitecto class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

!Arquitecto methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 18:06'!
requerisCatering
	^((self isMemberOf:  Gerente) | (self isMemberOf:  ProjectLeader))! !

Object subclass: #DisenadorDeSistemas
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

DisenadorDeSistemas class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

Object subclass: #DisenadorGrafico
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

DisenadorGrafico class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

Object subclass: #Edificio
	uses: ConstructorConNombre
	instanceVariableNames: 'nombre salas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Edificio class
	uses: ConstructorConNombre classTrait
	instanceVariableNames: ''!

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/21/2012 00:05'!
agregarSala: aSala
	self salas add: aSala.! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:48'!
buscaUnaSalaXEvento: anEvento

	^self salas detect:[:each | each estasLibreEnEsteEvento: anEvento].! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:01'!
initialize
	salas := OrderedCollection new.
	! !

!Edificio methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:02'!
nombre: anObject
	nombre := anObject! !

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/20/2012 23:47'!
salas
	^ salas! !

Object subclass: #Empresa
	instanceVariableNames: 'edificios herramientas personas proyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:46'!
agregarPersona: aPersona 
	self personas add: aPersona.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:39'!
agregarProyecto: unProyecto 
	(self proyectos) add: unProyecto.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ArielCapozzoli 4/25/2012 19:05'!
buscaSalaXEvento: anEvento
|sala|
	self edificios do: [:edificio| sala = edificio buscaUnaSalaXEvento: anEvento. sala ifNotNilDo: [^sala] ].
	^nil
! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:17'!
buscarPersonasRequeridas: coleccionFiltros
	^coleccionFiltros collect: [:unFiltro | unFiltro buscarPersonaQueTeCumple: personas]! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios
	^ edificios! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios: anObject
	edificios := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas
	^ herramientas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas: anObject
	herramientas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:38'!
initialize 
	personas:= OrderedCollection new.
	herramientas:= OrderedCollection new.
	proyectos:= OrderedCollection new.
	edificios:= OrderedCollection new.! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas
	^ personas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas: anObject
	personas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos
	^ proyectos! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #Evento
	instanceVariableNames: 'horaInicio horaFin fecha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Evento class methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/23/2012 15:41'!
horaInicio: hi horaFin: hf
	^(self new) horaInicio:hi; horaFin: hf; fecha:Date today;yourself.! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:33'!
<=otroEvento
	(self fecha = otroEvento fecha) ifTrue:[^(self horaInicio <= otroEvento horaInicio)] ifFalse: [^(self fecha <= otroEvento fecha)].
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:26'!
acotarSegun:otroEvento
	|condicion contenidoDentro|
	condicion:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].

	"cota superior superpuesta"
	(condicion value: (self horaInicio)) ifTrue: [ self horaInicio: (otroEvento horaFin)].

	"cota inferior superpuesta"
	(condicion value: (self horaFin)) ifTrue: [ self horaFin: (otroEvento horaInicio)].

	
! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 18:31'!
ajustarInicio: horaEntrada fin:horaSalida
	 (self horaInicio < horaEntrada) ifTrue: [self horaInicio: horaEntrada].
	 (self horaFin > horaSalida) ifTrue: [self horaFin: horaSalida].
! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 15:31'!
comparteHoraInicioFinCon:otroEvento
	^((self horaInicio  = otroEvento horaInicio) & (self horaFin  = otroEvento horaFin))
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 16:27'!
duraMasQue: unaDuracion
	^((self horaInicio addTime: unaDuracion) <= (self horaFin))! !

!Evento methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/25/2012 19:31'!
esPosibleEmpezando: unaHoraInicio conDuracion: duracion  
	(self horaInicio > self horaFin)
	ifTrue: [^false].
	(((self horaInicio) addTime: duracion) > self horaFin)
	ifTrue: [^false].
	((unaHoraInicio addTime: duracion) > self horaFin)
	ifTrue: [^false]. 
	(self horaInicio > unaHoraInicio)
	ifFalse: [self horaInicio: unaHoraInicio].
	^true! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:27'!
estaContenidoDentroDe:otroEvento
	|contenidoDentro|
	contenidoDentro:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
		
	"uno contenido dentro de otro"
	^((contenidoDentro value: (self horaInicio)) & (contenidoDentro value: (self horaFin)))! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 00:43'!
fecha
	^ fecha! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
fecha: anObject
	fecha := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 15:51'!
fecha: fechaEvento horaInicio:horaInicioEvento horaFin:horaFinEvento
	self fecha: (Date readFrom: fechaEvento readStream).
	self horaInicio: (Time readFrom: horaInicioEvento readStream).
	self horaFin: (Time readFrom: horaFinEvento readStream).! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin
	^ horaFin! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin: anObject
	horaFin := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaInicio
	^ horaInicio! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
horaInicio: anObject
	horaInicio := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 16:22'!
horasQueDejaLibre
	|tiemposLibres diaCompleto| 
	tiemposLibres:= OrderedCollection new.
	diaCompleto :=Evento new.
	(diaCompleto horaInicio < self horaInicio) ifTrue: [tiemposLibres add: (Evento horaInicio: (diaCompleto horaInicio) horaFin: (self horaInicio))].
	(diaCompleto horaFin > self horaFin) ifTrue: [tiemposLibres add: (Evento horaInicio: (self horaFin) horaFin: (diaCompleto horaFin))].
	
	^tiemposLibres! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:56'!
initialize 
	horaInicio :=Time readFromString: '00:00'.
	horaFin := Time readFromString: '23:59'.
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 00:02'!
seSuperPoneCon:otroEvento
	|condicion contenidoDentro|
	"Bloques de condiciones para repetir menos"
	condicion:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
	contenidoDentro:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
		
	"Si es el mismo evento, entonces no se superponen."
	(self == otroEvento) ifTrue: [^false]
	
	"Si son diferentes, evaluamos los bloques."
	ifFalse:[^(	(condicion value: (self horaInicio)) | 		"cota superior superpuesta"
				(condicion value: (self horaFin)) | 		"cota inferior superpuesta"
				((contenidoDentro value: (self horaInicio)) & (contenidoDentro value: (self horaFin))))] "uno contenido dentro de otro"
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 15:29'!
seSuperPoneConAlgunOtroEvento:unaColeccionDeEventos
	^ unaColeccionDeEventos anySatisfy: [:unEvento | unEvento seSuperPoneCon: self].
! !

Object subclass: #Filtro
	instanceVariableNames: 'condiciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:08'!
agregarCondicion: unaCondicion
	condiciones add: unaCondicion ! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:11'!
aplicarA: unaPersona
	^condiciones allSatisfy:[:c| c value:unaPersona ]! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 17:48'!
buscarPersonaQueTeCumple: coleccionPersonas
	^coleccionPersonas detect: [:unaPersona | self aplicarA: unaPersona ] 
		ifNone:[^self error: 'Ninguna persona cumple con las condiciones del filtro.']! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:14'!
initialize 
	condiciones := OrderedCollection new.! !

Object subclass: #Gerente
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Gerente class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

Object subclass: #Herramienta
	uses: ConAgenda
	instanceVariableNames: 'costo agenda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Herramienta class
	uses: ConAgenda classTrait
	instanceVariableNames: ''!

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda
	^ agenda! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda: anObject
	agenda := anObject! !

!Herramienta methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 19:02'!
costo
	^ costo! !

!Herramienta methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 19:02'!
costo: anObject
	costo := anObject! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:22'!
initialize
	agenda := Agenda new.
	! !

Herramienta subclass: #RecursoLimitado
	instanceVariableNames: 'nombre cantidadTotal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad
	^ cantidadTotal! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad: anObject
	cantidadTotal := anObject! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
hay:unNumero paraEvento: unEvento
	| eventosEnFecha i eventoAux cantidadReservada noSumoTodavia|
	eventosEnFecha := (self agenda) recorrerAgendaEnDia: (unEvento fecha).
	i :=1.
	cantidadReservada:= 0.
	(eventosEnFecha size) timesRepeat:[
		eventoAux := eventosEnFecha at: i.
		noSumoTodavia := true.
		"si empiezan al mismo tiempo cuenta como reservado"
		(((eventoAux horaInicio)=(unEvento horaInicio))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
			].
		"si empieza despues, pero la otra no termino cuando esta empezo, cuenta como reservado"
		(((eventoAux horaInicio)<(unEvento horaInicio))&((eventoAux horaFin)>(unEvento horaInicio))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
		].
		"si la reservada empieza despues, pero esta no termino cuando la otra empezo, cuenta como reservado"
		(((eventoAux horaInicio)<(unEvento horaFin))&((eventoAux horaFin)>(unEvento horaFin))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
		].
		i:= i+1.		
	].
	unNumero<((self cantidad) - cantidadReservada)
	ifTrue:[
		^true].
	^false! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre
	^ nombre! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre: anObject
	nombre := anObject! !

Herramienta subclass: #Sala
	instanceVariableNames: 'nombre edificioEnElQueSeEncuentra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Sala class methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/22/2012 22:53'!
constructorConEdificio: unEdificio costo: unCosto

	^(self new) edificioEnElQueSeEncuentra: unEdificio; costo: unCosto;yourself.! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra
	^ edificioEnElQueSeEncuentra! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra: anObject
	edificioEnElQueSeEncuentra := anObject! !

!Sala methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:55'!
estasLibreEnEsteEvento: anEvento

	^(self agenda tieneTiempoLibreParaElEvento: anEvento)! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre
	^ nombre! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Persona
	uses: ConAgenda
	instanceVariableNames: 'nombre horaEntrada horaSalida proyectoAlQueEstaAsignado sector rol edificioEnElQueTrabaja valorPorHoraDeTrabajo agenda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Persona class
	uses: ConAgenda classTrait
	instanceVariableNames: ''!

!Persona class methodsFor: 'as yet unclassified' stamp: 'MartinPrete 5/2/2012 16:07'!
nombre: aName horaEntrada: horarioEntrada horaSalida: horarioSalida sueldo:unSueldo sector: unSector rol:unRol proyecto:unProyecto edificio:unEdificio

^(self new) nombre: aName;horaEntrada: horarioEntrada;horaSalida: horarioSalida;valorPorHoraDeTrabajo: unSueldo;sector: unSector;rol: unRol; proyectoAlQueEstaAsignado:unProyecto;edificioEnElQueTrabaja:unEdificio; yourself.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda
	^ agenda! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda: anObject
	agenda := anObject! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/25/2012 19:08'!
cualEsTuHorarioComunCon: personas
	| inicioFranjaComun finFranjaComun personaAux thisReunionEvent i |
	
	inicioFranjaComun := (self buscarMayorEn:  personas usandoComoValorInicial:(Persona new)  comprador: [:p|p horaEntrada]) horaEntrada.
	
	finFranjaComun := (self buscarMenorEn:  personas usandoComoValorInicial:(Persona new)  comprador: [:p|p horaSalida]) horaSalida.
	
	thisReunionEvent := Evento new.
	thisReunionEvent horaInicio: inicioFranjaComun.
	thisReunionEvent horaFin: finFranjaComun.
	
	^thisReunionEvent! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:56'!
dameTusTiemposLibresParaUnaReunionQueDure:unaDuracion 
	^(agenda tiemposLibresQueDurenComoMinimo: unaDuracion desde: horaEntrada hasta: horaSalida)! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja
	^ edificioEnElQueTrabaja! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja: anObject
	edificioEnElQueTrabaja := anObject! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaEntrada
	^ horaEntrada! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:40'!
horaEntrada: anObject
	horaEntrada := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaSalida
	^ horaSalida! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:40'!
horaSalida: anObject
	horaSalida := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/22/2012 20:09'!
initialize 
	agenda := Agenda new.
	horaEntrada := Time readFromString: '09:00'.
	horaSalida := Time readFromString: '18:00'.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado
	^ proyectoAlQueEstaAsignado! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado: anObject
	proyectoAlQueEstaAsignado := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/22/2012 18:07'!
rol: unaClaseRol
	rol := unaClaseRol new.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector: anObject
	sector := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 21:08'!
trabajasEnElProyecto: nombreProyecto 
	^(proyectoAlQueEstaAsignado nombre) = nombreProyecto.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
valorPorHoraDeTrabajo
	^ valorPorHoraDeTrabajo! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
valorPorHoraDeTrabajo: anObject
	valorPorHoraDeTrabajo := anObject! !

Object subclass: #Programador
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Programador class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

Object subclass: #ProjectLeader
	uses: TraitRol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

ProjectLeader class
	uses: TraitRol classTrait
	instanceVariableNames: ''!

Object subclass: #Proyecto
	uses: ConstructorConNombre
	instanceVariableNames: 'nombre costo personas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Proyecto class
	uses: ConstructorConNombre classTrait
	instanceVariableNames: ''!

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:45'!
agregarPersona: unaPersona
	unaPersona proyectoAlQueEstaAsignado: self.
	personas add: unaPersona.! !

!Proyecto methodsFor: 'accessing' stamp: 'NahuelBarroso 4/24/2012 14:51'!
costo
	^ costo! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 20:07'!
imputarCosto: unCosto
	costo := (costo+unCosto).! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:27'!
initialize 
	costo := 0.
	personas := OrderedCollection new.! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre: anObject
	nombre := anObject! !

Object subclass: #ReservaHerramienta
	instanceVariableNames: 'herramienta cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad
	^ cantidad! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad: anObject
	cantidad := anObject! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta
	^ herramienta! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta: anObject
	herramienta := anObject! !

Object subclass: #Reunion
	uses: TraitManejadorDeColecciones
	instanceVariableNames: 'personaQueLaConvoca sala herramientas requiereCatering personas proyectoQueLaRequirio horaInicio horaFin fecha duracion empresa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Reunion class
	uses: TraitManejadorDeColecciones classTrait
	instanceVariableNames: ''!

!Reunion class methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/22/2012 22:57'!
constructorConEmpresa: unaEmpresa personaConvocante: unaPersona duracion:unaDuracion

	^(self new) empresa: unaEmpresa;personaQueLaConvoca: unaPersona;duracion: (Duration hours: unaDuracion);yourself.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:49'!
AgendarEnTodos
	personas do:[ :p | p agendarReunion: self].
	herramientas do:[ :h | (h herramienta) agendarReunion: self ].	
	sala agendarReunion: self.
	  
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: 1.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta cuantas: unNumero
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: unNumero.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:33'!
calcularEImputarCostos
	"Imputa el costo de las Herramietas (Proyector, Laptop, etc...)"
	self imputarCostoHerramientas.

	"Imputa el costo de la sala"
	(self proyectoQueLaRequirio) imputarCosto: (sala costo).

	"Imputa el costo del transporte $50 x persona"
	self imputarCostoTransporte.

	"Imputa el costo de las personas que asisten"
	self imputarCostoPersonas.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/25/2012 23:16'!
duracion
	^duracion! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:31'!
duracion: anObject
	duracion := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa
	^empresa! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa: anObject
	empresa := anObject.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha
	^ fecha! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha: anObject
	fecha := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 23:53'!
fechaLibreEnAgendasPara: unEvento	
	| isValidDatePersonas isValidDateHerramientas isValidDateSala |
	
	unEvento fecha: self fecha.
	
	isValidDatePersonas := false.
	isValidDateHerramientas:= false.
	isValidDateSala:= false.
	
	[isValidDatePersonas & isValidDateHerramientas & isValidDateSala]
	whileFalse:
	[	
		self fecha: ((self fecha) addDays:1).
		unEvento fecha: self fecha.
		isValidDateHerramientas := self fechaLibreHerramientasPara: unEvento.
		isValidDatePersonas := self fechaLibrePersonasPara: unEvento.
		isValidDateSala := self fechaLibreSalaPara: unEvento.
	].
	
! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/21/2012 02:18'!
fechaLibreHerramientasPara: unEvento	
	|herramientaAux hayHerramientas i |
	i := 1.
	hayHerramientas := true.
	(herramientas size) timesRepeat:
	[
		herramientaAux := herramientas at: i.
		((herramientaAux herramienta) hay: (herramientaAux cantidad) paraEvento: unEvento)ifFalse:[
			hayHerramientas := false.].
		i = i+1.
	].
	^hayHerramientas! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/21/2012 02:19'!
fechaLibrePersonasPara: unEvento	
	|superAgendaPersonas personaAux i estanLibres |
		
	superAgendaPersonas := Agenda new.
	i := 1.
	(personas size) timesRepeat:
	[
		personaAux := personas at: i.
		(superAgendaPersonas eventos) addAll: ((personaAux agenda) eventosEnLaFecha: (self fecha)).
		i := i +1.	
	].
	estanLibres := unEvento seSuperPoneConAlgunOtroEvento: (superAgendaPersonas eventos).
	^(estanLibres not).
! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/25/2012 19:04'!
fechaLibreSalaPara: unEvento
	| salaAux|
	sala ifNil: [salaAux := (self empresa)buscaSalaXEvento: unEvento.
		(salaAux) ifNil:[
			^false
			].
		self sala: salaAux.
		^true
		] 
		 ifNotNil:[salaAux := sala estasLibreEnEsteEvento: unEvento.
			(salaAux) ifTrue:[
				^true
				].
			^false
		].
	
	
	
	
! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:14'!
horaFin
	^horaFin.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaFin: unaHora
	horaFin:= unaHora.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:17'!
horaInicio
	^ horaInicio! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaInicio: unaHora
	horaInicio:= unaHora.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:55'!
horarioEnElQuePuedeRealizarse
	| i personaAux thisReunionEvent superAgendaPersonas fechaAux|
	
	thisReunionEvent := ((self personaQueLaConvoca) cualEsTuHorarioComunCon: personas).    
	
	(thisReunionEvent esPosibleEmpezando: (self horaInicio) conDuracion:(self duracion))   
		ifFalse: [^self error: 'La reunion no puede realizarse dado que las personas elegidas no comparten horario laboral'].
	  
	"fechaAux := self fechaLibreEnAgendasPara: thisReunionEvent."
	fechaAux := Date today.
	thisReunionEvent fecha: fechaAux.
	
	self AgendarEnTodos.
	. 
	^ 'La Reunion ha sido puesta para el dia ',(thisReunionEvent fecha asString), ' a la hora ',(thisReunionEvent horaInicio asString),'. Los asistentes seran: ',((personas collect: [:e|e nombre]) inject: '' into: [:a :c | a,' ',c]).! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 15:06'!
imputarCostoHerramientas
	herramientas do:[ :unaHerramienta | (self proyectoQueLaRequirio) imputarCosto: unaHerramienta costo].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:35'!
imputarCostoPersonas
	personas do:[ :unaPersona | (self proyectoQueLaRequirio) imputarCosto: ((unaPersona valorPorHoraDeTrabajo) * (duracion hours))].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:34'!
imputarCostoTransporte
	self proyectoQueLaRequirio imputarCosto: ((self personasQueRequierenTransporte) size) * 50.! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 18:36'!
initialize 
	requiereCatering :=false.
	personas := OrderedCollection new.
	herramientas:= OrderedCollection new.
	self fecha: Date today.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/25/2012 23:16'!
personaQueLaConvoca
	^personaQueLaConvoca! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:59'!
personaQueLaConvoca: unaPersona
	personaQueLaConvoca := unaPersona.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:03'!
personas
	^ personas! !

!Reunion methodsFor: 'accessing' stamp: 'NahuelBarroso 4/24/2012 14:29'!
personas: anObject
	personas := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:32'!
personasDeOtrosProyectos
	^(self personas select: [:unaPersona | (unaPersona trabajasEnElProyecto:  ((self proyectoQueLaRequirio) nombre)) not])
	
	
! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:34'!
personasQueRequierenTransporte
	^(self personasDeOtrosProyectos) select:[:unaPersona | unaPersona edificioEnElQueTrabaja ~= (self sala edificioEnElQueSeEncuentra)].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 21:00'!
proyectoQueLaRequirio
	^ personaQueLaConvoca proyectoAlQueEstaAsignado.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/22/2012 17:54'!
requiereCatering
	^ requiereCatering | personas anySatisfy:[:unaPersona | (unaPersona rol requerisCatering)].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala
	^ sala! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala: anObject
	sala := anObject! !
